﻿using EJGrid.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using System.Xml;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {
        public static List<Orders> order = new List<Orders>();
        //int gerenate = 10048;


        public ActionResult Index()
        {
            if(order.Count == 0)
            BindDataSource();
            return View();
        }
        private void BindDataSource()
        {
            int orderId = 10000;
            int empId = 0;
            for (int i = 1; i < 9; i++)
            {
                order.Add(new Orders(orderId + 1, "VINET", empId + 1, 32.38, new DateTime(2014, 12, 25), "Reims"));
                order.Add(new Orders(orderId + 2, "TOMSP", empId + 2, 11.61, new DateTime(2014, 12, 21), "Munster"));
                order.Add(new Orders(orderId + 3, "ANATER", empId + 3, 45.34, new DateTime(2014, 10, 18), "Berlin"));
                order.Add(new Orders(orderId + 4, "ALFKI", empId + 4, 37.28, new DateTime(2014, 11, 23), "Mexico"));
                order.Add(new Orders(orderId + 5, "FRGYE", empId + 5, 67.00, new DateTime(2014, 05, 05), "Colchester"));
                order.Add(new Orders(orderId + 6, "JGERT", empId + 6, 23.32, new DateTime(2014, 10, 18), "Newyork"));
                orderId += 6;
                empId += 6;
            }
           
            
        }
        [Serializable]
        public class Orders
        {
            public Orders()
            {
            }
            public Orders(int orderId, string customerId, int empId, double freight, DateTime orderDate, string shipCity)
            {
                this.OrderID = orderId;
                this.CustomerID = customerId;
                this.EmployeeID = empId;
                this.Freight = freight;
                this.OrderDate = orderDate;
                this.ShipCity = shipCity;
            }
            public int OrderID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
        }
       
        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            // DataResult result = new DataResult();
           // BindDataSource();
            IEnumerable Data = order.ToList();
            int count = Data.AsQueryable().Count();
            Syncfusion.JavaScript.DataSources.DataOperations operation = new Syncfusion.JavaScript.DataSources.DataOperations();
            Data = operation.Execute(Data, dm);
            return Json(new { result = Data, count = count }, JsonRequestBehavior.AllowGet);
        }

        public ActionResult DataSource1(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable DataSource = OrderRepository.GetAllRecords().Select(c => c.CustomerID).ToList();
            DataOperations ds = new DataOperations();
            DataResult result = new DataResult();
            result.result = DataSource;
            result.count = DataSource.AsQueryable().Count();
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable aggregate { get; set; }
            public IEnumerable groupDs { get; set; }
        }
        public ActionResult Update(Orders value)
       {

            //OrderRepository.Update(value);
            //var data = OrderRepository.GetAllRecords();
            var data = order.ToList();
            Orders result = data.Where(o => o.OrderID == value.OrderID).FirstOrDefault();
            if (result != null)
            {
                result.OrderID = value.OrderID;
                
                result.CustomerID = value.CustomerID;
                result.EmployeeID = value.EmployeeID;
                
            }

           // var data = order.ToList();
          //  data.Add(value);
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(Orders value)
        {
            int generate = order.ToList().Count();
            value.OrderID = ++generate;
            //var data = order.ToList();
            order.Insert(0, value);
      
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Delete(int key)
        {
            var data = order.ToList();
            Orders result = data.Where(o => o.OrderID == key).FirstOrDefault();
            order.Remove(result);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public JsonResult GetData(int EmployeeID)
        {
            var data = OrderRepository.GetAllRecords().Where(ds => ds.EmployeeID == EmployeeID).ToList();
           
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}