﻿namespace EJGrid.Models
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web;
    using EJGrid.Models;
    using System.Data.SqlClient;
    using System.Data;
    using System.Data.Entity;

    
    public static class OrderRepository
    {
        public static IList<EditableOrder> GetAllRecords()
        {
            IList<EditableOrder> orders =  (from ord in new NORTHWNDEntities().Orders
                                                                  select new EditableOrder
                                                                  {
                                                                      OrderID = ord.OrderID,
                                                                      OrderDate = ord.OrderDate,
                                                                      CustomerID = ord.CustomerID,
                                                                      EmployeeID = ord.EmployeeID,
                                                                      Freight = ord.Freight,
                                                                      ShipAddress = ord.ShipAddress,
                                                                      ShipCity = ord.ShipCity,
                                                                      ShipName = ord.ShipName,
                                                                      ShipPostalCode = ord.ShipPostalCode,
                                                                      ShipRegion = ord.ShipRegion,
                                                                      Country = ord.ShipCountry
                                                                  }).ToList();
            foreach (var order in orders)
            {
                if (order.Freight > 30)
                {
                    order.Verified = true;
                    order.Child = new ChildItem(){ Test=25.2m};

                }
                else
                {
                    order.Verified = false;
                    order.Child = new ChildItem() { Test = 52.2m };
                }
                //if (order.EmployeeID == 1)
                //    order.Country = null;

            }
            return orders;
        }

        public static void Add(EditableOrder order)
        {
            GetAllRecords().Insert(0, order);
        }

        public static void Add(List<EditableOrder> order)
        {
            foreach (var temp in order)
                GetAllRecords().Insert(0, temp);
        }

        public static void Delete(int OrderID)
        {
            EditableOrder result = GetAllRecords().Where(o => o.OrderID == OrderID).FirstOrDefault();
            GetAllRecords().Remove(result);
        }

        public static void Delete(List<EditableOrder> order)
        {
            foreach (var temp in order)
            {
                EditableOrder result = GetAllRecords().Where(o => o.OrderID == temp.OrderID).FirstOrDefault();
                GetAllRecords().Remove(result);
            }
        }

        public static void Update(EditableOrder order)
        {
            EditableOrder result = GetAllRecords().Where(o => o.OrderID == order.OrderID).FirstOrDefault();
            if (result != null)
            {
                result.OrderID = order.OrderID;
                result.OrderDate = order.OrderDate;
                result.CustomerID = order.CustomerID;
                result.EmployeeID = order.EmployeeID;
                result.Freight = order.Freight;
                result.ShipAddress = order.ShipAddress;
                result.ShipCity = order.ShipCity;
                result.ShipName = order.ShipName;
                result.ShipPostalCode = order.ShipPostalCode;
                result.ShipRegion = order.ShipRegion;
                result.Verified = order.Verified;
            }
        }              

        //public static IList<EMployee> GetAllRecords2()
        //{
        //    IList<EMployee> orders = (from ord in new Model1().EmployeeViews
        //                              select new EMployee
        //                                   {
        //                                         EmployeeID = ord.EmployeeID,
        //                                          Title= ord.Title,
        //                                          FirstName = ord.FirstName,
        //                                          City = ord.City,
        //                                          Country = ord.Country
        //                                   }).ToList();
        //    var ords = GetAllRecords();
        //    foreach(var ord in orders)
        //    ord.TrueCount = ords.Where(ds => (ds.Verified == true && ds.EmployeeID == ord.EmployeeID)).Count();
        //    return orders;
        //}
        //public static void Delete(List<Order> Order)
        //{
        //    DataClasses1DataContext db = new DataClasses1DataContext();
        //    foreach (var ord in Order)
        //    {
        //        var rec = db.Orders.Find(ord.OrderID);
        //        db.Orders.Remove(rec);
        //        db.SaveChanges();
        //    }
        //}


        //public static void Update(List<Order> order)
        //{

        //    NORTHWNDEntities db = new NORTHWNDEntities();
        //    foreach (var ord in order)
        //    {
        //        db.Entry(ord).State = EntityState.Modified;


        //        db.SaveChanges();
        //    }
        //}
        

        
    }
}
